using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Products;
namespace CMSMicroservice.Protobuf.Validator.Products;

public class DeleteProductsRequestValidator : AbstractValidator<DeleteProductsRequest>
{
    public DeleteProductsRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<DeleteProductsRequest>.CreateWithOptions((DeleteProductsRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
